unit Unit1;

interface

uses
  tiltHawkVoice,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  NMUDP, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    udp: TNMUDP;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure udpDataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    hawk: TTiltWaveHawkVoice; //hawkVoice
    inStream, outStream: TMemoryStream; //streams de envio/recebimento de dados

    //Chamado quando um buffer foi preenchido com dados do microfone
    procedure hawkBufferCheio(sender: TObject; buffer: pointer; size: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.hawkBufferCheio(sender: TObject; buffer: pointer; size: integer);
begin
     //limpa o stream de sada
     outStream.Clear;

     //escreve o buffer lido para o stream
     outStream.Write(buffer^, size);

     //envia o stream para o computador remoto
     udp.SendStream(outStream);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     //cria um hawkVoice
     hawk:= TTiltWaveHawkVoice.Create;

     //coloca o evento de bufferCheio no hawkVoice 
     hawk.OnBufferCheio:= hawkBufferCheio;

     //cria streams de envio/recebimento
     inStream:= TMemoryStream.create;
     outStream:= TMemoryStream.create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     //libera o hawkVoice
     hawk.free;

     //libera os streams
     inStream.free;
     outStream.free;
end;

procedure TForm1.udpDataReceived(Sender: TComponent; NumberBytes: Integer;
  FromIP: String; Port: Integer);
begin
     //limpa o stream de entrada
     inStream.Clear;

     //l os dados recebidos para o stream
     udp.ReadStream(inStream);

     //envia o buffer recebido para decodificao
     hawk.bufferChegou(inStream.Memory, inStream.Size);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
     //especifica o destino dos pacotes de voz
     udp.RemoteHost:= Edit1.text;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     //habilita/desabilita gravao
     hawk.Gravando:= CheckBox1.Checked;

     //no pode mudar o codec enquanto est gravando...
     ComboBox1.Enabled:= not hawk.Gravando;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     //escolhe o codec de codificao
     hawk.EncodeCoded:= ComboBox1.ItemIndex +1;
end;

end.
